//Interleaved orbsMod01.fsh
//https://glslsandbox.com/e#78035.0
// Licence CC0
// Adapted, trivialy, for use in VGHD player
/////////////////////////////////////////////
uniform float u_Elapsed;    // The elapsed time in seconds
uniform vec2  u_WindowSize; // Window dimensions in pixels


#define time u_Elapsed*0.1666
#define resolution u_WindowSize


//#define mouse AUTO_MOUSE
//#define MOUSE_SPEED vec2(vec2(0.5,0.577777) * 0.25)
//#define MOUSE_POS   vec2((1.0+cos(iGlobalTime*MOUSE_SPEED))*u_WindowSize/2.0)
//#define MOUSE_PRESS vec2(0.0,0.0)
//#define AUTO_MOUSE  vec4( MOUSE_POS, MOUSE_PRESS )
//#define RIGID_SCROLL
// alternatively use static mouse definition
#define mouse vec4(0.0,0.0, 0.0,0.0)









#ifdef GL_ES
precision highp float;
#endif

///uniform vec2 resolution;
//uniform float time;

//https://codepen.io/ilithya/pen/poyMNvG
	
#define PI 3.14159265359

// Pallete function by Inigo Quilez - iquilezles.org
vec3 palette(in float t, in vec3 a, in vec3 b, in vec3 c, in vec3 d) { return a + b*cos( 6.28318*(c*t+d) ); }
			
void main( void ) {
	vec2 uv = gl_FragCoord.xy/resolution.xy;
	uv.x *= resolution.x/resolution.y;

	float wave = PI * 2.;
	float anim_01 = sin(time/1.5);
	float anim_02 = cos(time/2.5);
	float size = 2.15;
	float amount = 1.73;

	/* Frequency is the combiantion of oscilation and phase. */
	/* Oscillation is the repetitive variation. */
	/* Phase is an angle representing the number of periods spanned by that variable. */
	
	vec3 color_palette = palette(
		.5, // Keep the color spectrum balanced
		vec3(fract(sin(uv.x*wave)*anim_01 * size + cos(uv.y*wave)*anim_02*amount + uv.yyx)), // shape 
		vec3(fract(cos(uv.x*wave)*anim_02 * size + sin(uv.y*wave)*anim_01*amount + uv.xxy)), // mirror shape
		vec3(sin(time/2.)/2., .06, 1.0), // Color
		vec3(.5) // Keep the color spectrum balanced
	);	
	
	gl_FragColor = vec4(color_palette, 1.0);
}